from ....tl.mtproto_request import MTProtoRequest


class GetMaskStickersRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messages.getMaskStickers#65b8c79f hash:int = messages.AllStickers"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x65b8c79f
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x45834829

    def __init__(self, hash):
        """
        :param hash: Telegram type: "int".

        :returns messages.AllStickers: Instance of either AllStickersNotModified, AllStickers.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.hash = hash

    def to_dict(self):
        return {
            'hash': self.hash,
        }

    def on_send(self, writer):
        writer.write_int(GetMaskStickersRequest.constructor_id, signed=False)
        writer.write_int(self.hash)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetMaskStickersRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.getMaskStickers#65b8c79f hash:int = messages.AllStickers'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
