from ....tl.mtproto_request import MTProtoRequest


class SetEncryptedTypingRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messages.setEncryptedTyping#791451ed peer:InputEncryptedChat typing:Bool = Bool"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x791451ed
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xf5b399ac

    def __init__(self, peer, typing):
        """
        :param peer: Telegram type: "InputEncryptedChat".
        :param typing: Telegram type: "Bool".

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.peer = peer
        self.typing = typing

    def to_dict(self):
        return {
            'peer': None if self.peer is None else self.peer.to_dict(),
            'typing': self.typing,
        }

    def on_send(self, writer):
        writer.write_int(SetEncryptedTypingRequest.constructor_id, signed=False)
        self.peer.on_send(writer)
        writer.tgwrite_bool(self.typing)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return SetEncryptedTypingRequest(None, None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'messages.setEncryptedTyping#791451ed peer:InputEncryptedChat typing:Bool = Bool'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
