from ....tl.mtproto_request import MTProtoRequest


class RemoveStickerFromSetRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    stickers.removeStickerFromSet#04255934 sticker:InputDocument = Bool"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x4255934
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xf5b399ac

    def __init__(self, sticker):
        """
        :param sticker: Telegram type: "InputDocument".

        :returns Bool: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.sticker = sticker

    def to_dict(self):
        return {
            'sticker': None if self.sticker is None else self.sticker.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(RemoveStickerFromSetRequest.constructor_id, signed=False)
        self.sticker.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return RemoveStickerFromSetRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_object()

    def __repr__(self):
        return 'stickers.removeStickerFromSet#04255934 sticker:InputDocument = Bool'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
