from ....tl.mtproto_request import MTProtoRequest
from ....utils import get_input_user


class GetUsersRequest(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    users.getUsers#0d91a548 id:Vector<InputUser> = Vector<User>"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xd91a548
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x406da4d

    def __init__(self, id):
        """
        :param id: Telegram type: "InputUser". Must be a list.

        :returns Vector<User>: This type has no constructors.
        """
        super().__init__()
        self.result = None
        self.confirmed = True  # Confirmed by default

        self.id = [get_input_user(_x) for _x in id]

    def to_dict(self):
        return {
            'id': [] if self.id is None else [None if x is None else x.to_dict() for x in self.id],
        }

    def on_send(self, writer):
        writer.write_int(GetUsersRequest.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.id))
        for _x in self.id:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return GetUsersRequest(None)

    def on_response(self, reader):
        self.result = reader.tgread_vector()

    def __repr__(self):
        return 'users.getUsers#0d91a548 id:Vector<InputUser> = Vector<User>'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
