from ...tl.mtproto_request import MTProtoRequest


class ChannelParticipantAdmin(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    channelParticipantAdmin#a82fa898 flags:# can_edit:flags.0?true user_id:int inviter_id:int promoted_by:int date:int admin_rights:ChannelAdminRights = ChannelParticipant"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xa82fa898
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xd9c7fc18

    def __init__(self, user_id, inviter_id, promoted_by, date, admin_rights, can_edit=None):
        """
        :param can_edit: Telegram type: "true".
        :param user_id: Telegram type: "int".
        :param inviter_id: Telegram type: "int".
        :param promoted_by: Telegram type: "int".
        :param date: Telegram type: "date".
        :param admin_rights: Telegram type: "ChannelAdminRights".

        Constructor for ChannelParticipant: Instance of either ChannelParticipant, ChannelParticipantSelf, ChannelParticipantCreator, ChannelParticipantAdmin, ChannelParticipantBanned.
        """
        super().__init__()

        self.can_edit = can_edit
        self.user_id = user_id
        self.inviter_id = inviter_id
        self.promoted_by = promoted_by
        self.date = date
        self.admin_rights = admin_rights

    def to_dict(self):
        return {
            'can_edit': self.can_edit,
            'user_id': self.user_id,
            'inviter_id': self.inviter_id,
            'promoted_by': self.promoted_by,
            'date': self.date,
            'admin_rights': None if self.admin_rights is None else self.admin_rights.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(ChannelParticipantAdmin.constructor_id, signed=False)
        # Calculate the flags. This equals to those flag arguments which are NOT None
        flags = 0
        flags |= (1 << 0) if self.can_edit else 0
        writer.write_int(flags)

        writer.write_int(self.user_id)
        writer.write_int(self.inviter_id)
        writer.write_int(self.promoted_by)
        writer.tgwrite_date(self.date)
        self.admin_rights.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ChannelParticipantAdmin(None, None, None, None, None, None)

    def on_response(self, reader):
        flags = reader.read_int()

        if (flags & (1 << 0)) != 0:
            self.can_edit = True  # Arbitrary not-None value, no need to read since it is a flag

        self.user_id = reader.read_int()
        self.inviter_id = reader.read_int()
        self.promoted_by = reader.read_int()
        self.date = reader.tgread_date()
        self.admin_rights = reader.tgread_object()

    def __repr__(self):
        return 'channelParticipantAdmin#a82fa898 flags:# can_edit:flags.0?true user_id:int inviter_id:int promoted_by:int date:int admin_rights:ChannelAdminRights = ChannelParticipant'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
