from ...tl.mtproto_request import MTProtoRequest


class ChatParticipantCreator(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    chatParticipantCreator#da13538a user_id:int = ChatParticipant"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xda13538a
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x7d7c6f86

    def __init__(self, user_id):
        """
        :param user_id: Telegram type: "int".

        Constructor for ChatParticipant: Instance of either ChatParticipant, ChatParticipantCreator, ChatParticipantAdmin.
        """
        super().__init__()

        self.user_id = user_id

    def to_dict(self):
        return {
            'user_id': self.user_id,
        }

    def on_send(self, writer):
        writer.write_int(ChatParticipantCreator.constructor_id, signed=False)
        writer.write_int(self.user_id)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ChatParticipantCreator(None)

    def on_response(self, reader):
        self.user_id = reader.read_int()

    def __repr__(self):
        return 'chatParticipantCreator#da13538a user_id:int = ChatParticipant'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
