from ...tl.mtproto_request import MTProtoRequest


class Contact(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    contact#f911c994 user_id:int mutual:Bool = Contact"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xf911c994
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x83dfdfa4

    def __init__(self, user_id, mutual):
        """
        :param user_id: Telegram type: "int".
        :param mutual: Telegram type: "Bool".

        Constructor for Contact: Instance of Contact.
        """
        super().__init__()

        self.user_id = user_id
        self.mutual = mutual

    def to_dict(self):
        return {
            'user_id': self.user_id,
            'mutual': self.mutual,
        }

    def on_send(self, writer):
        writer.write_int(Contact.constructor_id, signed=False)
        writer.write_int(self.user_id)
        writer.tgwrite_bool(self.mutual)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return Contact(None, None)

    def on_response(self, reader):
        self.user_id = reader.read_int()
        self.mutual = reader.tgread_bool()

    def __repr__(self):
        return 'contact#f911c994 user_id:int mutual:Bool = Contact'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
