from ...tl.mtproto_request import MTProtoRequest


class InputBotInlineResultPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputBotInlineResultPhoto#a8d864a7 id:string type:string photo:InputPhoto send_message:InputBotInlineMessage = InputBotInlineResult"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xa8d864a7
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x80a4a3de

    def __init__(self, id, type, photo, send_message):
        """
        :param id: Telegram type: "string".
        :param type: Telegram type: "string".
        :param photo: Telegram type: "InputPhoto".
        :param send_message: Telegram type: "InputBotInlineMessage".

        Constructor for InputBotInlineResult: Instance of either InputBotInlineResult, InputBotInlineResultPhoto, InputBotInlineResultDocument, InputBotInlineResultGame.
        """
        super().__init__()

        self.id = id
        self.type = type
        self.photo = photo
        self.send_message = send_message

    def to_dict(self):
        return {
            'id': self.id,
            'type': self.type,
            'photo': None if self.photo is None else self.photo.to_dict(),
            'send_message': None if self.send_message is None else self.send_message.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(InputBotInlineResultPhoto.constructor_id, signed=False)
        writer.tgwrite_string(self.id)
        writer.tgwrite_string(self.type)
        self.photo.on_send(writer)
        self.send_message.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputBotInlineResultPhoto(None, None, None, None)

    def on_response(self, reader):
        self.id = reader.tgread_string()
        self.type = reader.tgread_string()
        self.photo = reader.tgread_object()
        self.send_message = reader.tgread_object()

    def __repr__(self):
        return 'inputBotInlineResultPhoto#a8d864a7 id:string type:string photo:InputPhoto send_message:InputBotInlineMessage = InputBotInlineResult'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
