from ...tl.mtproto_request import MTProtoRequest


class InputMediaDocument(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputMediaDocument#1a77f29c id:InputDocument caption:string = InputMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x1a77f29c
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xfaf846f4

    def __init__(self, id, caption):
        """
        :param id: Telegram type: "InputDocument".
        :param caption: Telegram type: "string".

        Constructor for InputMedia: Instance of either InputMediaEmpty, InputMediaUploadedPhoto, InputMediaPhoto, InputMediaGeoPoint, InputMediaContact, InputMediaUploadedDocument, InputMediaUploadedThumbDocument, InputMediaDocument, InputMediaVenue, InputMediaGifExternal, InputMediaPhotoExternal, InputMediaDocumentExternal, InputMediaGame, InputMediaInvoice.
        """
        super().__init__()

        self.id = id
        self.caption = caption

    def to_dict(self):
        return {
            'id': None if self.id is None else self.id.to_dict(),
            'caption': self.caption,
        }

    def on_send(self, writer):
        writer.write_int(InputMediaDocument.constructor_id, signed=False)
        self.id.on_send(writer)
        writer.tgwrite_string(self.caption)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputMediaDocument(None, None)

    def on_response(self, reader):
        self.id = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaDocument#1a77f29c id:InputDocument caption:string = InputMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
