from ...tl.mtproto_request import MTProtoRequest


class InputMediaGifExternal(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputMediaGifExternal#4843b0fd url:string q:string = InputMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x4843b0fd
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xfaf846f4

    def __init__(self, url, q):
        """
        :param url: Telegram type: "string".
        :param q: Telegram type: "string".

        Constructor for InputMedia: Instance of either InputMediaEmpty, InputMediaUploadedPhoto, InputMediaPhoto, InputMediaGeoPoint, InputMediaContact, InputMediaUploadedDocument, InputMediaUploadedThumbDocument, InputMediaDocument, InputMediaVenue, InputMediaGifExternal, InputMediaPhotoExternal, InputMediaDocumentExternal, InputMediaGame, InputMediaInvoice.
        """
        super().__init__()

        self.url = url
        self.q = q

    def to_dict(self):
        return {
            'url': self.url,
            'q': self.q,
        }

    def on_send(self, writer):
        writer.write_int(InputMediaGifExternal.constructor_id, signed=False)
        writer.tgwrite_string(self.url)
        writer.tgwrite_string(self.q)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputMediaGifExternal(None, None)

    def on_response(self, reader):
        self.url = reader.tgread_string()
        self.q = reader.tgread_string()

    def __repr__(self):
        return 'inputMediaGifExternal#4843b0fd url:string q:string = InputMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
