from ...tl.mtproto_request import MTProtoRequest


class InputStickeredMediaDocument(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    inputStickeredMediaDocument#0438865b id:InputDocument = InputStickeredMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x438865b
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x5146d99e

    def __init__(self, id):
        """
        :param id: Telegram type: "InputDocument".

        Constructor for InputStickeredMedia: Instance of either InputStickeredMediaPhoto, InputStickeredMediaDocument.
        """
        super().__init__()

        self.id = id

    def to_dict(self):
        return {
            'id': None if self.id is None else self.id.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(InputStickeredMediaDocument.constructor_id, signed=False)
        self.id.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return InputStickeredMediaDocument(None)

    def on_response(self, reader):
        self.id = reader.tgread_object()

    def __repr__(self):
        return 'inputStickeredMediaDocument#0438865b id:InputDocument = InputStickeredMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
