from ...tl.mtproto_request import MTProtoRequest


class MessageActionChatEditTitle(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageActionChatEditTitle#b5a1ce5a title:string = MessageAction"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xb5a1ce5a
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x8680d126

    def __init__(self, title):
        """
        :param title: Telegram type: "string".

        Constructor for MessageAction: Instance of either MessageActionEmpty, MessageActionChatCreate, MessageActionChatEditTitle, MessageActionChatEditPhoto, MessageActionChatDeletePhoto, MessageActionChatAddUser, MessageActionChatDeleteUser, MessageActionChatJoinedByLink, MessageActionChannelCreate, MessageActionChatMigrateTo, MessageActionChannelMigrateFrom, MessageActionPinMessage, MessageActionHistoryClear, MessageActionGameScore, MessageActionPaymentSentMe, MessageActionPaymentSent, MessageActionPhoneCall.
        """
        super().__init__()

        self.title = title

    def to_dict(self):
        return {
            'title': self.title,
        }

    def on_send(self, writer):
        writer.write_int(MessageActionChatEditTitle.constructor_id, signed=False)
        writer.tgwrite_string(self.title)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageActionChatEditTitle(None)

    def on_response(self, reader):
        self.title = reader.tgread_string()

    def __repr__(self):
        return 'messageActionChatEditTitle#b5a1ce5a title:string = MessageAction'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
