from ...tl.mtproto_request import MTProtoRequest


class MessageEntityPre(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageEntityPre#73924be0 offset:int length:int language:string = MessageEntity"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x73924be0
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xcf6419dc

    def __init__(self, offset, length, language):
        """
        :param offset: Telegram type: "int".
        :param length: Telegram type: "int".
        :param language: Telegram type: "string".

        Constructor for MessageEntity: Instance of either MessageEntityUnknown, MessageEntityMention, MessageEntityHashtag, MessageEntityBotCommand, MessageEntityUrl, MessageEntityEmail, MessageEntityBold, MessageEntityItalic, MessageEntityCode, MessageEntityPre, MessageEntityTextUrl, MessageEntityMentionName, InputMessageEntityMentionName.
        """
        super().__init__()

        self.offset = offset
        self.length = length
        self.language = language

    def to_dict(self):
        return {
            'offset': self.offset,
            'length': self.length,
            'language': self.language,
        }

    def on_send(self, writer):
        writer.write_int(MessageEntityPre.constructor_id, signed=False)
        writer.write_int(self.offset)
        writer.write_int(self.length)
        writer.tgwrite_string(self.language)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageEntityPre(None, None, None)

    def on_response(self, reader):
        self.offset = reader.read_int()
        self.length = reader.read_int()
        self.language = reader.tgread_string()

    def __repr__(self):
        return 'messageEntityPre#73924be0 offset:int length:int language:string = MessageEntity'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
