from ...tl.mtproto_request import MTProtoRequest


class MessageMediaDocument(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageMediaDocument#f3e02ea8 document:Document caption:string = MessageMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xf3e02ea8
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x476cbe32

    def __init__(self, document, caption):
        """
        :param document: Telegram type: "Document".
        :param caption: Telegram type: "string".

        Constructor for MessageMedia: Instance of either MessageMediaEmpty, MessageMediaPhoto, MessageMediaGeo, MessageMediaContact, MessageMediaUnsupported, MessageMediaDocument, MessageMediaWebPage, MessageMediaVenue, MessageMediaGame, MessageMediaInvoice.
        """
        super().__init__()

        self.document = document
        self.caption = caption

    def to_dict(self):
        return {
            'document': None if self.document is None else self.document.to_dict(),
            'caption': self.caption,
        }

    def on_send(self, writer):
        writer.write_int(MessageMediaDocument.constructor_id, signed=False)
        self.document.on_send(writer)
        writer.tgwrite_string(self.caption)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageMediaDocument(None, None)

    def on_response(self, reader):
        self.document = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'messageMediaDocument#f3e02ea8 document:Document caption:string = MessageMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
