from ...tl.mtproto_request import MTProtoRequest


class MessageMediaGame(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageMediaGame#fdb19008 game:Game = MessageMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0xfdb19008
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x476cbe32

    def __init__(self, game):
        """
        :param game: Telegram type: "Game".

        Constructor for MessageMedia: Instance of either MessageMediaEmpty, MessageMediaPhoto, MessageMediaGeo, MessageMediaContact, MessageMediaUnsupported, MessageMediaDocument, MessageMediaWebPage, MessageMediaVenue, MessageMediaGame, MessageMediaInvoice.
        """
        super().__init__()

        self.game = game

    def to_dict(self):
        return {
            'game': None if self.game is None else self.game.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(MessageMediaGame.constructor_id, signed=False)
        self.game.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageMediaGame(None)

    def on_response(self, reader):
        self.game = reader.tgread_object()

    def __repr__(self):
        return 'messageMediaGame#fdb19008 game:Game = MessageMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
