from ...tl.mtproto_request import MTProtoRequest


class MessageMediaPhoto(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    messageMediaPhoto#3d8ce53d photo:Photo caption:string = MessageMedia"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x3d8ce53d
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x476cbe32

    def __init__(self, photo, caption):
        """
        :param photo: Telegram type: "Photo".
        :param caption: Telegram type: "string".

        Constructor for MessageMedia: Instance of either MessageMediaEmpty, MessageMediaPhoto, MessageMediaGeo, MessageMediaContact, MessageMediaUnsupported, MessageMediaDocument, MessageMediaWebPage, MessageMediaVenue, MessageMediaGame, MessageMediaInvoice.
        """
        super().__init__()

        self.photo = photo
        self.caption = caption

    def to_dict(self):
        return {
            'photo': None if self.photo is None else self.photo.to_dict(),
            'caption': self.caption,
        }

    def on_send(self, writer):
        writer.write_int(MessageMediaPhoto.constructor_id, signed=False)
        self.photo.on_send(writer)
        writer.tgwrite_string(self.caption)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MessageMediaPhoto(None, None)

    def on_response(self, reader):
        self.photo = reader.tgread_object()
        self.caption = reader.tgread_string()

    def __repr__(self):
        return 'messageMediaPhoto#3d8ce53d photo:Photo caption:string = MessageMedia'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
