from ...tl.mtproto_request import MTProtoRequest


class MsgsAck(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    msgs_ack#62d6b459 msg_ids:Vector<long> = MsgsAck"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x62d6b459
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0x827677c4

    def __init__(self, msg_ids):
        """
        :param msg_ids: Telegram type: "long". Must be a list.

        Constructor for MsgsAck: Instance of MsgsAck.
        """
        super().__init__()

        self.msg_ids = msg_ids

    def to_dict(self):
        return {
            'msg_ids': [] if self.msg_ids is None else self.msg_ids[:],
        }

    def on_send(self, writer):
        writer.write_int(MsgsAck.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.msg_ids))
        for _x in self.msg_ids:
            writer.write_long(_x)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return MsgsAck(None)

    def on_response(self, reader):
        reader.read_int()  # Vector's constructor ID
        self.msg_ids = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.read_long()
            self.msg_ids.append(_x)

    def __repr__(self):
        return 'msgs_ack#62d6b459 msg_ids:Vector<long> = MsgsAck'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
