from ...tl.mtproto_request import MTProtoRequest


class NotifyPeer(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    notifyPeer#9fd40bd8 peer:Peer = NotifyPeer"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x9fd40bd8
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xdfe8602e

    def __init__(self, peer):
        """
        :param peer: Telegram type: "Peer".

        Constructor for NotifyPeer: Instance of either NotifyPeer, NotifyUsers, NotifyChats, NotifyAll.
        """
        super().__init__()

        self.peer = peer

    def to_dict(self):
        return {
            'peer': None if self.peer is None else self.peer.to_dict(),
        }

    def on_send(self, writer):
        writer.write_int(NotifyPeer.constructor_id, signed=False)
        self.peer.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return NotifyPeer(None)

    def on_response(self, reader):
        self.peer = reader.tgread_object()

    def __repr__(self):
        return 'notifyPeer#9fd40bd8 peer:Peer = NotifyPeer'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
