from ...tl.mtproto_request import MTProtoRequest


class ReplyInlineMarkup(MTProtoRequest):
    """Class generated by TLObjects' generator. All changes will be ERASED. TL definition below.
    replyInlineMarkup#48a30254 rows:Vector<KeyboardButtonRow> = ReplyMarkup"""

    # Telegram's constructor (U)ID for this class
    constructor_id = 0x48a30254
    # Also the ID of its resulting type for fast checks
    subclass_of_id = 0xe2e10ef2

    def __init__(self, rows):
        """
        :param rows: Telegram type: "KeyboardButtonRow". Must be a list.

        Constructor for ReplyMarkup: Instance of either ReplyKeyboardHide, ReplyKeyboardForceReply, ReplyKeyboardMarkup, ReplyInlineMarkup.
        """
        super().__init__()

        self.rows = rows

    def to_dict(self):
        return {
            'rows': [] if self.rows is None else [None if x is None else x.to_dict() for x in self.rows],
        }

    def on_send(self, writer):
        writer.write_int(ReplyInlineMarkup.constructor_id, signed=False)
        writer.write_int(0x1cb5c415, signed=False)  # Vector's constructor ID
        writer.write_int(len(self.rows))
        for _x in self.rows:
            _x.on_send(writer)

    @staticmethod
    def empty():
        """Returns an "empty" instance (attributes=None)"""
        return ReplyInlineMarkup(None)

    def on_response(self, reader):
        reader.read_int()  # Vector's constructor ID
        self.rows = []  # Initialize an empty list
        _len = reader.read_int()
        for _ in range(_len):
            _x = reader.tgread_object()
            self.rows.append(_x)

    def __repr__(self):
        return 'replyInlineMarkup#48a30254 rows:Vector<KeyboardButtonRow> = ReplyMarkup'

    def __str__(self):
        return MTProtoRequest.pretty_format(self)

    def stringify(self):
        return MTProtoRequest.pretty_format(self, indent=0)
